/* chess-window.c generated by valac 0.56.17, the Vala compiler
 * generated from chess-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2024 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include "libchess.h"
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define HISTORY_GO_FIRST_ACTION_NAME "go-first"
#define HISTORY_GO_PREVIOUS_ACTION_NAME "go-previous"
#define HISTORY_GO_NEXT_ACTION_NAME "go-next"
#define HISTORY_GO_LAST_ACTION_NAME "go-last"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHESS_WINDOW (chess_window_get_type ())
#define CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_WINDOW, ChessWindow))
#define CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_WINDOW, ChessWindowClass))
#define IS_CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_WINDOW))
#define IS_CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_WINDOW))
#define CHESS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_WINDOW, ChessWindowClass))

typedef struct _ChessWindow ChessWindow;
typedef struct _ChessWindowClass ChessWindowClass;
typedef struct _ChessWindowPrivate ChessWindowPrivate;
typedef enum  {
	CHESS_WINDOW_LAYOUT_MODE_NORMAL,
	CHESS_WINDOW_LAYOUT_MODE_NARROW
} ChessWindowLayoutMode;

#define CHESS_WINDOW_TYPE_LAYOUT_MODE (chess_window_layout_mode_get_type ())

#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;

#define TYPE_CHESS_APPLICATION (chess_application_get_type ())
#define CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_APPLICATION, ChessApplication))
#define CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_APPLICATION, ChessApplicationClass))
#define IS_CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_APPLICATION))
#define IS_CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_APPLICATION))
#define CHESS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_APPLICATION, ChessApplicationClass))

typedef struct _ChessApplication ChessApplication;
typedef struct _ChessApplicationClass ChessApplicationClass;
enum  {
	CHESS_WINDOW_0_PROPERTY,
	CHESS_WINDOW_LAYOUT_MODE_PROPERTY,
	CHESS_WINDOW_VIEW_PROPERTY,
	CHESS_WINDOW_SCENE_PROPERTY,
	CHESS_WINDOW_GAME_PROPERTY,
	CHESS_WINDOW_NUM_PROPERTIES
};
static GParamSpec* chess_window_properties[CHESS_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessWindow {
	AdwApplicationWindow parent_instance;
	ChessWindowPrivate * priv;
};

struct _ChessWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _ChessWindowPrivate {
	ChessWindowLayoutMode _layout_mode;
	ChessView* _view;
	ChessApplication* app;
	AdwToastOverlay* toast_overlay;
	GtkButton* pause_resume_button;
	GtkBox* navigation_box;
	GtkComboBox* history_combo;
	GtkBox* clock_box;
	GtkDrawingArea* white_time_label;
	GtkDrawingArea* black_time_label;
};

struct _Block2Data {
	int _ref_count_;
	ChessWindow* self;
	GtkWidget* widget;
	cairo_t* c;
};

struct _Block3Data {
	int _ref_count_;
	ChessWindow* self;
	ChessWindowLayoutMode value;
};

static gint ChessWindow_private_offset;
static gpointer chess_window_parent_class = NULL;

VALA_EXTERN GType chess_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessWindow, g_object_unref)
VALA_EXTERN GType chess_window_layout_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType chess_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessView, g_object_unref)
VALA_EXTERN GType chess_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessApplication, g_object_unref)
VALA_EXTERN ChessWindow* chess_window_new (ChessApplication* app);
VALA_EXTERN ChessWindow* chess_window_construct (GType object_type,
                                     ChessApplication* app);
VALA_EXTERN GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
VALA_EXTERN ChessScene* chess_scene_new (void);
VALA_EXTERN ChessScene* chess_scene_construct (GType object_type);
static void __lambda41_ (ChessWindow* self);
VALA_EXTERN void chess_window_update_history_panel (ChessWindow* self);
static void ___lambda41__chess_scene_changed (ChessScene* _sender,
                                       gpointer self);
VALA_EXTERN ChessView* chess_view_new (ChessScene* scene);
VALA_EXTERN ChessView* chess_view_construct (GType object_type,
                                 ChessScene* scene);
static void chess_window_set_view (ChessWindow* self,
                            ChessView* value);
VALA_EXTERN ChessView* chess_window_get_view (ChessWindow* self);
VALA_EXTERN void chess_window_update_pause_resume_button (ChessWindow* self);
static void chess_window_draw_white_time_label (ChessWindow* self,
                                         GtkDrawingArea* drawing_area,
                                         cairo_t* c,
                                         gint width,
                                         gint height);
static void _chess_window_draw_white_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void chess_window_draw_black_time_label (ChessWindow* self,
                                         GtkDrawingArea* drawing_area,
                                         cairo_t* c,
                                         gint width,
                                         gint height);
static void _chess_window_draw_black_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                     cairo_t* cr,
                                                                     gint width,
                                                                     gint height,
                                                                     gpointer self);
static void chess_window_window_state_changed_cb (ChessWindow* self);
static void _chess_window_window_state_changed_cb_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
VALA_EXTERN ChessWindowLayoutMode chess_window_get_layout_mode (ChessWindow* self);
static void chess_window_set_layout_mode (ChessWindow* self,
                                   ChessWindowLayoutMode value);
VALA_EXTERN void chess_window_update_game_status (ChessWindow* self,
                                      const gchar* title,
                                      const gchar* info);
VALA_EXTERN gchar* chess_application_compute_current_title (ChessApplication* self);
VALA_EXTERN gchar* chess_application_compute_status_info (ChessApplication* self);
VALA_EXTERN ChessScene* chess_window_get_scene (ChessWindow* self);
VALA_EXTERN ChessGame* chess_scene_get_game (ChessScene* self);
VALA_EXTERN ChessGame* chess_window_get_game (ChessWindow* self);
VALA_EXTERN gint chess_scene_get_move_number (ChessScene* self);
VALA_EXTERN void chess_application_enable_action (ChessApplication* self,
                                      const gchar* name);
VALA_EXTERN void chess_application_disable_action (ChessApplication* self,
                                       const gchar* name);
VALA_EXTERN void chess_window_set_move_text (ChessWindow* self,
                                 GtkTreeIter* iter,
                                 ChessMove* move);
VALA_EXTERN void chess_window_set_clock_visible (ChessWindow* self,
                                     gboolean visible);
static gint chess_window_compute_time_label_width_request (ChessWindow* self,
                                                    cairo_t* c);
static void chess_window_draw_time (ChessWindow* self,
                             GtkWidget* widget,
                             cairo_t* c,
                             gint width,
                             gint height,
                             const gchar* text,
                             gdouble* fg,
                             gint fg_length1,
                             gdouble* bg,
                             gint bg_length1);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda42_ (Block2Data* _data2_);
static gboolean ____lambda42__gsource_func (gpointer self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static gchar* chess_window_make_clock_text (ChessWindow* self,
                                     ChessClock* clock,
                                     Color color);
static void chess_window_history_combo_changed_cb (ChessWindow* self,
                                            GtkComboBox* combo);
VALA_EXTERN void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
static void _chess_window_history_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self);
VALA_EXTERN const gchar* chess_scene_get_move_format (ChessScene* self);
VALA_EXTERN void chess_window_start_game (ChessWindow* self);
static void ___lambda31_ (ChessWindow* self);
static void ____lambda31__chess_clock_tick (ChessClock* _sender,
                                     gpointer self);
VALA_EXTERN void chess_window_move (ChessWindow* self,
                        ChessMove* m);
VALA_EXTERN void chess_window_undo (ChessWindow* self);
VALA_EXTERN void chess_window_end_game (ChessWindow* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean _chess_window_layout_mode___lambda39_ (Block3Data* _data3_);
static gboolean __chess_window_layout_mode___lambda39__gsource_func (gpointer self);
VALA_EXTERN ChessScene* chess_view_get_scene (ChessView* self);
static void chess_window_finalize (GObject * obj);
static GType chess_window_get_type_once (void);
static void _vala_chess_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_chess_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
chess_window_get_instance_private (ChessWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ChessWindow_private_offset);
}

static GType
chess_window_layout_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{CHESS_WINDOW_LAYOUT_MODE_NORMAL, "CHESS_WINDOW_LAYOUT_MODE_NORMAL", "normal"}, {CHESS_WINDOW_LAYOUT_MODE_NARROW, "CHESS_WINDOW_LAYOUT_MODE_NARROW", "narrow"}, {0, NULL, NULL}};
	GType chess_window_layout_mode_type_id;
	chess_window_layout_mode_type_id = g_enum_register_static ("ChessWindowLayoutMode", values);
	return chess_window_layout_mode_type_id;
}

GType
chess_window_layout_mode_get_type (void)
{
	static volatile gsize chess_window_layout_mode_type_id__once = 0;
	if (g_once_init_enter (&chess_window_layout_mode_type_id__once)) {
		GType chess_window_layout_mode_type_id;
		chess_window_layout_mode_type_id = chess_window_layout_mode_get_type_once ();
		g_once_init_leave (&chess_window_layout_mode_type_id__once, chess_window_layout_mode_type_id);
	}
	return chess_window_layout_mode_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "../src/chess-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 311 "chess-window.c"
}

static void
__lambda41_ (ChessWindow* self)
{
#line 77 "../src/chess-window.vala"
	chess_window_update_history_panel (self);
#line 319 "chess-window.c"
}

static void
___lambda41__chess_scene_changed (ChessScene* _sender,
                                  gpointer self)
{
#line 77 "../src/chess-window.vala"
	__lambda41_ ((ChessWindow*) self);
#line 328 "chess-window.c"
}

static void
_chess_window_draw_white_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 84 "../src/chess-window.vala"
	chess_window_draw_white_time_label ((ChessWindow*) self, drawing_area, cr, width, height);
#line 340 "chess-window.c"
}

static void
_chess_window_draw_black_time_label_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                                cairo_t* cr,
                                                                gint width,
                                                                gint height,
                                                                gpointer self)
{
#line 85 "../src/chess-window.vala"
	chess_window_draw_black_time_label ((ChessWindow*) self, drawing_area, cr, width, height);
#line 352 "chess-window.c"
}

static void
_chess_window_window_state_changed_cb_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 87 "../src/chess-window.vala"
	chess_window_window_state_changed_cb ((ChessWindow*) self);
#line 362 "chess-window.c"
}

ChessWindow*
chess_window_construct (GType object_type,
                        ChessApplication* app)
{
	ChessWindow * self = NULL;
	ChessApplication* _tmp0_;
	ChessScene* scene = NULL;
	ChessScene* _tmp1_;
	ChessView* _tmp2_;
	ChessView* _tmp3_;
	AdwToastOverlay* _tmp4_;
	ChessView* _tmp5_;
	GtkDrawingArea* _tmp6_;
	GtkDrawingArea* _tmp7_;
#line 72 "../src/chess-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 72 "../src/chess-window.vala"
	self = (ChessWindow*) g_object_new (object_type, NULL);
#line 74 "../src/chess-window.vala"
	_tmp0_ = _g_object_ref0 (app);
#line 74 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->app);
#line 74 "../src/chess-window.vala"
	self->priv->app = _tmp0_;
#line 76 "../src/chess-window.vala"
	_tmp1_ = chess_scene_new ();
#line 76 "../src/chess-window.vala"
	scene = _tmp1_;
#line 77 "../src/chess-window.vala"
	g_signal_connect_object (scene, "changed", (GCallback) ___lambda41__chess_scene_changed, self, 0);
#line 79 "../src/chess-window.vala"
	_tmp2_ = chess_view_new (scene);
#line 79 "../src/chess-window.vala"
	g_object_ref_sink (_tmp2_);
#line 79 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 79 "../src/chess-window.vala"
	chess_window_set_view (self, _tmp3_);
#line 79 "../src/chess-window.vala"
	_g_object_unref0 (_tmp3_);
#line 80 "../src/chess-window.vala"
	_tmp4_ = self->priv->toast_overlay;
#line 80 "../src/chess-window.vala"
	_tmp5_ = self->priv->_view;
#line 80 "../src/chess-window.vala"
	adw_toast_overlay_set_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 82 "../src/chess-window.vala"
	chess_window_update_pause_resume_button (self);
#line 84 "../src/chess-window.vala"
	_tmp6_ = self->priv->white_time_label;
#line 84 "../src/chess-window.vala"
	gtk_drawing_area_set_draw_func (_tmp6_, _chess_window_draw_white_time_label_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 85 "../src/chess-window.vala"
	_tmp7_ = self->priv->black_time_label;
#line 85 "../src/chess-window.vala"
	gtk_drawing_area_set_draw_func (_tmp7_, _chess_window_draw_black_time_label_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 87 "../src/chess-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::default-height", (GCallback) _chess_window_window_state_changed_cb_g_object_notify, self, 0);
#line 88 "../src/chess-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::default-width", (GCallback) _chess_window_window_state_changed_cb_g_object_notify, self, 0);
#line 72 "../src/chess-window.vala"
	_g_object_unref0 (scene);
#line 72 "../src/chess-window.vala"
	return self;
#line 429 "chess-window.c"
}

ChessWindow*
chess_window_new (ChessApplication* app)
{
#line 72 "../src/chess-window.vala"
	return chess_window_construct (TYPE_CHESS_WINDOW, app);
#line 437 "chess-window.c"
}

static void
chess_window_window_state_changed_cb (ChessWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp10_ = FALSE;
	gint _tmp11_;
	gint _tmp12_;
#line 91 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/chess-window.vala"
	g_object_get ((GtkWindow*) self, "fullscreened", &_tmp1_, NULL);
#line 93 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 93 "../src/chess-window.vala"
	if (_tmp2_) {
#line 93 "../src/chess-window.vala"
		_tmp0_ = TRUE;
#line 462 "chess-window.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 93 "../src/chess-window.vala"
		g_object_get ((GtkWindow*) self, "maximized", &_tmp3_, NULL);
#line 93 "../src/chess-window.vala"
		_tmp4_ = _tmp3_;
#line 93 "../src/chess-window.vala"
		_tmp0_ = _tmp4_;
#line 472 "chess-window.c"
	}
#line 93 "../src/chess-window.vala"
	if (_tmp0_) {
#line 94 "../src/chess-window.vala"
		return;
#line 478 "chess-window.c"
	}
#line 96 "../src/chess-window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp6_, NULL);
#line 96 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 96 "../src/chess-window.vala"
	if (_tmp7_ == 0) {
#line 96 "../src/chess-window.vala"
		_tmp5_ = TRUE;
#line 488 "chess-window.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 96 "../src/chess-window.vala"
		g_object_get ((GtkWindow*) self, "default-height", &_tmp8_, NULL);
#line 96 "../src/chess-window.vala"
		_tmp9_ = _tmp8_;
#line 96 "../src/chess-window.vala"
		_tmp5_ = _tmp9_ == 0;
#line 498 "chess-window.c"
	}
#line 96 "../src/chess-window.vala"
	if (_tmp5_) {
#line 97 "../src/chess-window.vala"
		return;
#line 504 "chess-window.c"
	}
#line 99 "../src/chess-window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp11_, NULL);
#line 99 "../src/chess-window.vala"
	_tmp12_ = _tmp11_;
#line 99 "../src/chess-window.vala"
	if (_tmp12_ <= 500) {
#line 512 "chess-window.c"
		ChessWindowLayoutMode _tmp13_;
		ChessWindowLayoutMode _tmp14_;
#line 99 "../src/chess-window.vala"
		_tmp13_ = chess_window_get_layout_mode (self);
#line 99 "../src/chess-window.vala"
		_tmp14_ = _tmp13_;
#line 99 "../src/chess-window.vala"
		_tmp10_ = _tmp14_ == CHESS_WINDOW_LAYOUT_MODE_NORMAL;
#line 521 "chess-window.c"
	} else {
#line 99 "../src/chess-window.vala"
		_tmp10_ = FALSE;
#line 525 "chess-window.c"
	}
#line 99 "../src/chess-window.vala"
	if (_tmp10_) {
#line 100 "../src/chess-window.vala"
		chess_window_set_layout_mode (self, CHESS_WINDOW_LAYOUT_MODE_NARROW);
#line 531 "chess-window.c"
	} else {
		gboolean _tmp15_ = FALSE;
		gint _tmp16_;
		gint _tmp17_;
#line 101 "../src/chess-window.vala"
		g_object_get ((GtkWindow*) self, "default-width", &_tmp16_, NULL);
#line 101 "../src/chess-window.vala"
		_tmp17_ = _tmp16_;
#line 101 "../src/chess-window.vala"
		if (_tmp17_ > 500) {
#line 542 "chess-window.c"
			ChessWindowLayoutMode _tmp18_;
			ChessWindowLayoutMode _tmp19_;
#line 101 "../src/chess-window.vala"
			_tmp18_ = chess_window_get_layout_mode (self);
#line 101 "../src/chess-window.vala"
			_tmp19_ = _tmp18_;
#line 101 "../src/chess-window.vala"
			_tmp15_ = _tmp19_ == CHESS_WINDOW_LAYOUT_MODE_NARROW;
#line 551 "chess-window.c"
		} else {
#line 101 "../src/chess-window.vala"
			_tmp15_ = FALSE;
#line 555 "chess-window.c"
		}
#line 101 "../src/chess-window.vala"
		if (_tmp15_) {
#line 102 "../src/chess-window.vala"
			chess_window_set_layout_mode (self, CHESS_WINDOW_LAYOUT_MODE_NORMAL);
#line 561 "chess-window.c"
		}
	}
}

void
chess_window_update_game_status (ChessWindow* self,
                                 const gchar* title,
                                 const gchar* info)
{
	gchar* _tmp0_ = NULL;
	gchar* toast = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp8_;
#line 105 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/chess-window.vala"
	if (title != NULL) {
#line 580 "chess-window.c"
		gchar* _tmp1_;
#line 107 "../src/chess-window.vala"
		_tmp1_ = g_strdup (title);
#line 107 "../src/chess-window.vala"
		_g_free0 (_tmp0_);
#line 107 "../src/chess-window.vala"
		_tmp0_ = _tmp1_;
#line 588 "chess-window.c"
	} else {
		ChessApplication* _tmp2_;
		gchar* _tmp3_;
#line 107 "../src/chess-window.vala"
		_tmp2_ = self->priv->app;
#line 107 "../src/chess-window.vala"
		_tmp3_ = chess_application_compute_current_title (_tmp2_);
#line 107 "../src/chess-window.vala"
		_g_free0 (_tmp0_);
#line 107 "../src/chess-window.vala"
		_tmp0_ = _tmp3_;
#line 600 "chess-window.c"
	}
#line 107 "../src/chess-window.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
#line 109 "../src/chess-window.vala"
	_tmp4_ = g_strdup (info);
#line 109 "../src/chess-window.vala"
	toast = _tmp4_;
#line 110 "../src/chess-window.vala"
	_tmp5_ = toast;
#line 110 "../src/chess-window.vala"
	if (_tmp5_ == NULL) {
#line 612 "chess-window.c"
		ChessApplication* _tmp6_;
		gchar* _tmp7_;
#line 111 "../src/chess-window.vala"
		_tmp6_ = self->priv->app;
#line 111 "../src/chess-window.vala"
		_tmp7_ = chess_application_compute_status_info (_tmp6_);
#line 111 "../src/chess-window.vala"
		_g_free0 (toast);
#line 111 "../src/chess-window.vala"
		toast = _tmp7_;
#line 623 "chess-window.c"
	}
#line 112 "../src/chess-window.vala"
	_tmp8_ = toast;
#line 112 "../src/chess-window.vala"
	if (_tmp8_ != NULL) {
#line 629 "chess-window.c"
		AdwToastOverlay* _tmp9_;
		const gchar* _tmp10_;
		AdwToast* _tmp11_;
#line 113 "../src/chess-window.vala"
		_tmp9_ = self->priv->toast_overlay;
#line 113 "../src/chess-window.vala"
		_tmp10_ = toast;
#line 113 "../src/chess-window.vala"
		_tmp11_ = adw_toast_new (_tmp10_);
#line 113 "../src/chess-window.vala"
		adw_toast_overlay_add_toast (_tmp9_, _tmp11_);
#line 641 "chess-window.c"
	}
#line 105 "../src/chess-window.vala"
	_g_free0 (toast);
#line 105 "../src/chess-window.vala"
	_g_free0 (_tmp0_);
#line 647 "chess-window.c"
}

void
chess_window_update_pause_resume_button (ChessWindow* self)
{
	ChessGame* game = NULL;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	gboolean _tmp5_ = FALSE;
	ChessGame* _tmp6_;
	gboolean _tmp12_ = FALSE;
	ChessGame* _tmp13_;
#line 116 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 118 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 118 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 118 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 118 "../src/chess-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 118 "../src/chess-window.vala"
	game = _tmp4_;
#line 120 "../src/chess-window.vala"
	_tmp6_ = game;
#line 120 "../src/chess-window.vala"
	if (_tmp6_ != NULL) {
#line 681 "chess-window.c"
		ChessGame* _tmp7_;
		ChessClock* _tmp8_;
		ChessClock* _tmp9_;
#line 120 "../src/chess-window.vala"
		_tmp7_ = game;
#line 120 "../src/chess-window.vala"
		_tmp8_ = chess_game_get_clock (_tmp7_);
#line 120 "../src/chess-window.vala"
		_tmp9_ = _tmp8_;
#line 120 "../src/chess-window.vala"
		_tmp5_ = _tmp9_ == NULL;
#line 693 "chess-window.c"
	} else {
#line 120 "../src/chess-window.vala"
		_tmp5_ = FALSE;
#line 697 "chess-window.c"
	}
#line 120 "../src/chess-window.vala"
	if (_tmp5_) {
#line 701 "chess-window.c"
		GtkButton* _tmp10_;
#line 121 "../src/chess-window.vala"
		_tmp10_ = self->priv->pause_resume_button;
#line 121 "../src/chess-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 707 "chess-window.c"
	} else {
		GtkButton* _tmp11_;
#line 123 "../src/chess-window.vala"
		_tmp11_ = self->priv->pause_resume_button;
#line 123 "../src/chess-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp11_);
#line 714 "chess-window.c"
	}
#line 125 "../src/chess-window.vala"
	_tmp13_ = game;
#line 125 "../src/chess-window.vala"
	if (_tmp13_ != NULL) {
#line 720 "chess-window.c"
		ChessGame* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 125 "../src/chess-window.vala"
		_tmp14_ = game;
#line 125 "../src/chess-window.vala"
		_tmp15_ = chess_game_get_is_paused (_tmp14_);
#line 125 "../src/chess-window.vala"
		_tmp16_ = _tmp15_;
#line 125 "../src/chess-window.vala"
		_tmp12_ = _tmp16_;
#line 732 "chess-window.c"
	} else {
#line 125 "../src/chess-window.vala"
		_tmp12_ = FALSE;
#line 736 "chess-window.c"
	}
#line 125 "../src/chess-window.vala"
	if (_tmp12_) {
#line 740 "chess-window.c"
		GtkButton* _tmp17_;
		GtkButton* _tmp18_;
#line 127 "../src/chess-window.vala"
		_tmp17_ = self->priv->pause_resume_button;
#line 127 "../src/chess-window.vala"
		gtk_button_set_icon_name (_tmp17_, "media-playback-start-symbolic");
#line 128 "../src/chess-window.vala"
		_tmp18_ = self->priv->pause_resume_button;
#line 128 "../src/chess-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp18_, _ ("Unpause the game"));
#line 751 "chess-window.c"
	} else {
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
#line 132 "../src/chess-window.vala"
		_tmp19_ = self->priv->pause_resume_button;
#line 132 "../src/chess-window.vala"
		gtk_button_set_icon_name (_tmp19_, "media-playback-pause-symbolic");
#line 133 "../src/chess-window.vala"
		_tmp20_ = self->priv->pause_resume_button;
#line 133 "../src/chess-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp20_, _ ("Pause the game"));
#line 763 "chess-window.c"
	}
#line 116 "../src/chess-window.vala"
	_g_object_unref0 (game);
#line 767 "chess-window.c"
}

void
chess_window_update_history_panel (ChessWindow* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	gint move_number = 0;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint n_moves = 0;
	ChessGame* _tmp6_;
	ChessGame* _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	GtkComboBox* _tmp40_;
	ChessGame* _tmp41_;
	ChessGame* _tmp42_;
	gboolean _tmp43_;
	gboolean _tmp44_;
	gint i = 0;
	ChessGame* _tmp45_;
	ChessGame* _tmp46_;
	GList* _tmp47_;
	GtkComboBox* _tmp60_;
#line 137 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_game (self);
#line 139 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 139 "../src/chess-window.vala"
	if (_tmp1_ == NULL) {
#line 140 "../src/chess-window.vala"
		return;
#line 811 "chess-window.c"
	}
#line 142 "../src/chess-window.vala"
	_tmp2_ = chess_window_get_scene (self);
#line 142 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 142 "../src/chess-window.vala"
	_tmp4_ = chess_scene_get_move_number (_tmp3_);
#line 142 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 142 "../src/chess-window.vala"
	move_number = _tmp5_;
#line 143 "../src/chess-window.vala"
	_tmp6_ = chess_window_get_game (self);
#line 143 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 143 "../src/chess-window.vala"
	_tmp8_ = chess_game_get_n_moves (_tmp7_);
#line 143 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 143 "../src/chess-window.vala"
	n_moves = (gint) _tmp9_;
#line 144 "../src/chess-window.vala"
	if (move_number < 0) {
#line 145 "../src/chess-window.vala"
		move_number += 1 + n_moves;
#line 837 "chess-window.c"
	}
#line 147 "../src/chess-window.vala"
	if (n_moves > 0) {
#line 147 "../src/chess-window.vala"
		_tmp11_ = move_number != 0;
#line 843 "chess-window.c"
	} else {
#line 147 "../src/chess-window.vala"
		_tmp11_ = FALSE;
#line 847 "chess-window.c"
	}
#line 147 "../src/chess-window.vala"
	if (_tmp11_) {
#line 851 "chess-window.c"
		ChessGame* _tmp12_;
		ChessGame* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
#line 147 "../src/chess-window.vala"
		_tmp12_ = chess_window_get_game (self);
#line 147 "../src/chess-window.vala"
		_tmp13_ = _tmp12_;
#line 147 "../src/chess-window.vala"
		_tmp14_ = chess_game_get_is_paused (_tmp13_);
#line 147 "../src/chess-window.vala"
		_tmp15_ = _tmp14_;
#line 147 "../src/chess-window.vala"
		_tmp10_ = !_tmp15_;
#line 866 "chess-window.c"
	} else {
#line 147 "../src/chess-window.vala"
		_tmp10_ = FALSE;
#line 870 "chess-window.c"
	}
#line 147 "../src/chess-window.vala"
	if (_tmp10_) {
#line 874 "chess-window.c"
		ChessApplication* _tmp16_;
#line 148 "../src/chess-window.vala"
		_tmp16_ = self->priv->app;
#line 148 "../src/chess-window.vala"
		chess_application_enable_action (_tmp16_, HISTORY_GO_FIRST_ACTION_NAME);
#line 880 "chess-window.c"
	} else {
		ChessApplication* _tmp17_;
#line 150 "../src/chess-window.vala"
		_tmp17_ = self->priv->app;
#line 150 "../src/chess-window.vala"
		chess_application_disable_action (_tmp17_, HISTORY_GO_FIRST_ACTION_NAME);
#line 887 "chess-window.c"
	}
#line 152 "../src/chess-window.vala"
	if (move_number > 0) {
#line 891 "chess-window.c"
		ChessGame* _tmp19_;
		ChessGame* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 152 "../src/chess-window.vala"
		_tmp19_ = chess_window_get_game (self);
#line 152 "../src/chess-window.vala"
		_tmp20_ = _tmp19_;
#line 152 "../src/chess-window.vala"
		_tmp21_ = chess_game_get_is_paused (_tmp20_);
#line 152 "../src/chess-window.vala"
		_tmp22_ = _tmp21_;
#line 152 "../src/chess-window.vala"
		_tmp18_ = !_tmp22_;
#line 906 "chess-window.c"
	} else {
#line 152 "../src/chess-window.vala"
		_tmp18_ = FALSE;
#line 910 "chess-window.c"
	}
#line 152 "../src/chess-window.vala"
	if (_tmp18_) {
#line 914 "chess-window.c"
		ChessApplication* _tmp23_;
#line 153 "../src/chess-window.vala"
		_tmp23_ = self->priv->app;
#line 153 "../src/chess-window.vala"
		chess_application_enable_action (_tmp23_, HISTORY_GO_PREVIOUS_ACTION_NAME);
#line 920 "chess-window.c"
	} else {
		ChessApplication* _tmp24_;
#line 155 "../src/chess-window.vala"
		_tmp24_ = self->priv->app;
#line 155 "../src/chess-window.vala"
		chess_application_disable_action (_tmp24_, HISTORY_GO_PREVIOUS_ACTION_NAME);
#line 927 "chess-window.c"
	}
#line 157 "../src/chess-window.vala"
	if (move_number < n_moves) {
#line 931 "chess-window.c"
		ChessGame* _tmp26_;
		ChessGame* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 157 "../src/chess-window.vala"
		_tmp26_ = chess_window_get_game (self);
#line 157 "../src/chess-window.vala"
		_tmp27_ = _tmp26_;
#line 157 "../src/chess-window.vala"
		_tmp28_ = chess_game_get_is_paused (_tmp27_);
#line 157 "../src/chess-window.vala"
		_tmp29_ = _tmp28_;
#line 157 "../src/chess-window.vala"
		_tmp25_ = !_tmp29_;
#line 946 "chess-window.c"
	} else {
#line 157 "../src/chess-window.vala"
		_tmp25_ = FALSE;
#line 950 "chess-window.c"
	}
#line 157 "../src/chess-window.vala"
	if (_tmp25_) {
#line 954 "chess-window.c"
		ChessApplication* _tmp30_;
#line 158 "../src/chess-window.vala"
		_tmp30_ = self->priv->app;
#line 158 "../src/chess-window.vala"
		chess_application_enable_action (_tmp30_, HISTORY_GO_NEXT_ACTION_NAME);
#line 960 "chess-window.c"
	} else {
		ChessApplication* _tmp31_;
#line 160 "../src/chess-window.vala"
		_tmp31_ = self->priv->app;
#line 160 "../src/chess-window.vala"
		chess_application_disable_action (_tmp31_, HISTORY_GO_NEXT_ACTION_NAME);
#line 967 "chess-window.c"
	}
#line 162 "../src/chess-window.vala"
	if (n_moves > 0) {
#line 162 "../src/chess-window.vala"
		_tmp33_ = move_number != n_moves;
#line 973 "chess-window.c"
	} else {
#line 162 "../src/chess-window.vala"
		_tmp33_ = FALSE;
#line 977 "chess-window.c"
	}
#line 162 "../src/chess-window.vala"
	if (_tmp33_) {
#line 981 "chess-window.c"
		ChessGame* _tmp34_;
		ChessGame* _tmp35_;
		gboolean _tmp36_;
		gboolean _tmp37_;
#line 162 "../src/chess-window.vala"
		_tmp34_ = chess_window_get_game (self);
#line 162 "../src/chess-window.vala"
		_tmp35_ = _tmp34_;
#line 162 "../src/chess-window.vala"
		_tmp36_ = chess_game_get_is_paused (_tmp35_);
#line 162 "../src/chess-window.vala"
		_tmp37_ = _tmp36_;
#line 162 "../src/chess-window.vala"
		_tmp32_ = !_tmp37_;
#line 996 "chess-window.c"
	} else {
#line 162 "../src/chess-window.vala"
		_tmp32_ = FALSE;
#line 1000 "chess-window.c"
	}
#line 162 "../src/chess-window.vala"
	if (_tmp32_) {
#line 1004 "chess-window.c"
		ChessApplication* _tmp38_;
#line 163 "../src/chess-window.vala"
		_tmp38_ = self->priv->app;
#line 163 "../src/chess-window.vala"
		chess_application_enable_action (_tmp38_, HISTORY_GO_LAST_ACTION_NAME);
#line 1010 "chess-window.c"
	} else {
		ChessApplication* _tmp39_;
#line 165 "../src/chess-window.vala"
		_tmp39_ = self->priv->app;
#line 165 "../src/chess-window.vala"
		chess_application_disable_action (_tmp39_, HISTORY_GO_LAST_ACTION_NAME);
#line 1017 "chess-window.c"
	}
#line 167 "../src/chess-window.vala"
	_tmp40_ = self->priv->history_combo;
#line 167 "../src/chess-window.vala"
	_tmp41_ = chess_window_get_game (self);
#line 167 "../src/chess-window.vala"
	_tmp42_ = _tmp41_;
#line 167 "../src/chess-window.vala"
	_tmp43_ = chess_game_get_is_paused (_tmp42_);
#line 167 "../src/chess-window.vala"
	_tmp44_ = _tmp43_;
#line 167 "../src/chess-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, !_tmp44_);
#line 170 "../src/chess-window.vala"
	i = n_moves;
#line 171 "../src/chess-window.vala"
	_tmp45_ = chess_window_get_game (self);
#line 171 "../src/chess-window.vala"
	_tmp46_ = _tmp45_;
#line 171 "../src/chess-window.vala"
	_tmp47_ = _tmp46_->move_stack;
#line 1039 "chess-window.c"
	{
		GList* state_collection = NULL;
		GList* state_it = NULL;
#line 171 "../src/chess-window.vala"
		state_collection = _tmp47_;
#line 171 "../src/chess-window.vala"
		for (state_it = state_collection; state_it != NULL; state_it = state_it->next) {
#line 1047 "chess-window.c"
			ChessState* _tmp48_;
			ChessState* state = NULL;
#line 171 "../src/chess-window.vala"
			_tmp48_ = _g_object_ref0 ((ChessState*) state_it->data);
#line 171 "../src/chess-window.vala"
			state = _tmp48_;
#line 1054 "chess-window.c"
			{
				ChessState* _tmp49_;
				ChessMove* _tmp50_;
				gint _tmp59_;
#line 173 "../src/chess-window.vala"
				_tmp49_ = state;
#line 173 "../src/chess-window.vala"
				_tmp50_ = _tmp49_->last_move;
#line 173 "../src/chess-window.vala"
				if (_tmp50_ != NULL) {
#line 1065 "chess-window.c"
					GtkTreeIter iter = {0};
					GtkComboBox* _tmp51_;
					GtkTreeModel* _tmp52_;
					GtkTreeModel* _tmp53_;
					GtkTreeIter _tmp54_ = {0};
					gboolean _tmp55_;
#line 176 "../src/chess-window.vala"
					_tmp51_ = self->priv->history_combo;
#line 176 "../src/chess-window.vala"
					_tmp52_ = gtk_combo_box_get_model (_tmp51_);
#line 176 "../src/chess-window.vala"
					_tmp53_ = _tmp52_;
#line 176 "../src/chess-window.vala"
					_tmp55_ = gtk_tree_model_iter_nth_child (_tmp53_, &_tmp54_, NULL, i);
#line 176 "../src/chess-window.vala"
					iter = _tmp54_;
#line 176 "../src/chess-window.vala"
					if (_tmp55_) {
#line 1084 "chess-window.c"
						GtkTreeIter _tmp56_;
						ChessState* _tmp57_;
						ChessMove* _tmp58_;
#line 177 "../src/chess-window.vala"
						_tmp56_ = iter;
#line 177 "../src/chess-window.vala"
						_tmp57_ = state;
#line 177 "../src/chess-window.vala"
						_tmp58_ = _tmp57_->last_move;
#line 177 "../src/chess-window.vala"
						chess_window_set_move_text (self, &_tmp56_, _tmp58_);
#line 1096 "chess-window.c"
					}
				}
#line 179 "../src/chess-window.vala"
				_tmp59_ = i;
#line 179 "../src/chess-window.vala"
				i = _tmp59_ - 1;
#line 171 "../src/chess-window.vala"
				_g_object_unref0 (state);
#line 1105 "chess-window.c"
			}
		}
	}
#line 182 "../src/chess-window.vala"
	_tmp60_ = self->priv->history_combo;
#line 182 "../src/chess-window.vala"
	gtk_combo_box_set_active (_tmp60_, move_number);
#line 1113 "chess-window.c"
}

void
chess_window_set_clock_visible (ChessWindow* self,
                                gboolean visible)
{
	GtkBox* _tmp0_;
#line 185 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/chess-window.vala"
	_tmp0_ = self->priv->clock_box;
#line 187 "../src/chess-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, visible);
#line 1127 "chess-window.c"
}

static gint
chess_window_compute_time_label_width_request (ChessWindow* self,
                                               cairo_t* c)
{
	cairo_text_extents_t extents = {0};
	gdouble max = 0.0;
	cairo_text_extents_t _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	cairo_text_extents_t _tmp6_;
	cairo_text_extents_t _tmp8_ = {0};
	gdouble _tmp9_ = 0.0;
	cairo_text_extents_t _tmp10_;
	cairo_text_extents_t _tmp12_ = {0};
	gdouble _tmp13_ = 0.0;
	cairo_text_extents_t _tmp14_;
	cairo_text_extents_t _tmp16_ = {0};
	gdouble _tmp17_ = 0.0;
	cairo_text_extents_t _tmp18_;
	cairo_text_extents_t _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	cairo_text_extents_t _tmp22_;
	cairo_text_extents_t _tmp24_ = {0};
	gdouble _tmp25_ = 0.0;
	cairo_text_extents_t _tmp26_;
	cairo_text_extents_t _tmp28_ = {0};
	gdouble _tmp29_ = 0.0;
	cairo_text_extents_t _tmp30_;
	cairo_text_extents_t _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	cairo_text_extents_t _tmp34_;
	cairo_text_extents_t _tmp36_ = {0};
	gdouble _tmp37_ = 0.0;
	cairo_text_extents_t _tmp38_;
	gint result;
#line 194 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 194 "../src/chess-window.vala"
	g_return_val_if_fail (c != NULL, 0);
#line 198 "../src/chess-window.vala"
	max = (gdouble) 0;
#line 200 "../src/chess-window.vala"
	cairo_text_extents (c, "000∶00", &_tmp0_);
#line 200 "../src/chess-window.vala"
	extents = _tmp0_;
#line 201 "../src/chess-window.vala"
	_tmp2_ = extents;
#line 201 "../src/chess-window.vala"
	if (max > _tmp2_.width) {
#line 201 "../src/chess-window.vala"
		_tmp1_ = max;
#line 1183 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp3_;
#line 201 "../src/chess-window.vala"
		_tmp3_ = extents;
#line 201 "../src/chess-window.vala"
		_tmp1_ = _tmp3_.width;
#line 1190 "chess-window.c"
	}
#line 201 "../src/chess-window.vala"
	max = _tmp1_;
#line 202 "../src/chess-window.vala"
	cairo_text_extents (c, "111∶11", &_tmp4_);
#line 202 "../src/chess-window.vala"
	extents = _tmp4_;
#line 203 "../src/chess-window.vala"
	_tmp6_ = extents;
#line 203 "../src/chess-window.vala"
	if (max > _tmp6_.width) {
#line 203 "../src/chess-window.vala"
		_tmp5_ = max;
#line 1204 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp7_;
#line 203 "../src/chess-window.vala"
		_tmp7_ = extents;
#line 203 "../src/chess-window.vala"
		_tmp5_ = _tmp7_.width;
#line 1211 "chess-window.c"
	}
#line 203 "../src/chess-window.vala"
	max = _tmp5_;
#line 204 "../src/chess-window.vala"
	cairo_text_extents (c, "222∶22", &_tmp8_);
#line 204 "../src/chess-window.vala"
	extents = _tmp8_;
#line 205 "../src/chess-window.vala"
	_tmp10_ = extents;
#line 205 "../src/chess-window.vala"
	if (max > _tmp10_.width) {
#line 205 "../src/chess-window.vala"
		_tmp9_ = max;
#line 1225 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp11_;
#line 205 "../src/chess-window.vala"
		_tmp11_ = extents;
#line 205 "../src/chess-window.vala"
		_tmp9_ = _tmp11_.width;
#line 1232 "chess-window.c"
	}
#line 205 "../src/chess-window.vala"
	max = _tmp9_;
#line 206 "../src/chess-window.vala"
	cairo_text_extents (c, "333∶33", &_tmp12_);
#line 206 "../src/chess-window.vala"
	extents = _tmp12_;
#line 207 "../src/chess-window.vala"
	_tmp14_ = extents;
#line 207 "../src/chess-window.vala"
	if (max > _tmp14_.width) {
#line 207 "../src/chess-window.vala"
		_tmp13_ = max;
#line 1246 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp15_;
#line 207 "../src/chess-window.vala"
		_tmp15_ = extents;
#line 207 "../src/chess-window.vala"
		_tmp13_ = _tmp15_.width;
#line 1253 "chess-window.c"
	}
#line 207 "../src/chess-window.vala"
	max = _tmp13_;
#line 208 "../src/chess-window.vala"
	cairo_text_extents (c, "444∶44", &_tmp16_);
#line 208 "../src/chess-window.vala"
	extents = _tmp16_;
#line 209 "../src/chess-window.vala"
	_tmp18_ = extents;
#line 209 "../src/chess-window.vala"
	if (max > _tmp18_.width) {
#line 209 "../src/chess-window.vala"
		_tmp17_ = max;
#line 1267 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp19_;
#line 209 "../src/chess-window.vala"
		_tmp19_ = extents;
#line 209 "../src/chess-window.vala"
		_tmp17_ = _tmp19_.width;
#line 1274 "chess-window.c"
	}
#line 209 "../src/chess-window.vala"
	max = _tmp17_;
#line 210 "../src/chess-window.vala"
	cairo_text_extents (c, "555∶55", &_tmp20_);
#line 210 "../src/chess-window.vala"
	extents = _tmp20_;
#line 211 "../src/chess-window.vala"
	_tmp22_ = extents;
#line 211 "../src/chess-window.vala"
	if (max > _tmp22_.width) {
#line 211 "../src/chess-window.vala"
		_tmp21_ = max;
#line 1288 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp23_;
#line 211 "../src/chess-window.vala"
		_tmp23_ = extents;
#line 211 "../src/chess-window.vala"
		_tmp21_ = _tmp23_.width;
#line 1295 "chess-window.c"
	}
#line 211 "../src/chess-window.vala"
	max = _tmp21_;
#line 212 "../src/chess-window.vala"
	cairo_text_extents (c, "666∶66", &_tmp24_);
#line 212 "../src/chess-window.vala"
	extents = _tmp24_;
#line 213 "../src/chess-window.vala"
	_tmp26_ = extents;
#line 213 "../src/chess-window.vala"
	if (max > _tmp26_.width) {
#line 213 "../src/chess-window.vala"
		_tmp25_ = max;
#line 1309 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp27_;
#line 213 "../src/chess-window.vala"
		_tmp27_ = extents;
#line 213 "../src/chess-window.vala"
		_tmp25_ = _tmp27_.width;
#line 1316 "chess-window.c"
	}
#line 213 "../src/chess-window.vala"
	max = _tmp25_;
#line 214 "../src/chess-window.vala"
	cairo_text_extents (c, "777∶77", &_tmp28_);
#line 214 "../src/chess-window.vala"
	extents = _tmp28_;
#line 215 "../src/chess-window.vala"
	_tmp30_ = extents;
#line 215 "../src/chess-window.vala"
	if (max > _tmp30_.width) {
#line 215 "../src/chess-window.vala"
		_tmp29_ = max;
#line 1330 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp31_;
#line 215 "../src/chess-window.vala"
		_tmp31_ = extents;
#line 215 "../src/chess-window.vala"
		_tmp29_ = _tmp31_.width;
#line 1337 "chess-window.c"
	}
#line 215 "../src/chess-window.vala"
	max = _tmp29_;
#line 216 "../src/chess-window.vala"
	cairo_text_extents (c, "888∶88", &_tmp32_);
#line 216 "../src/chess-window.vala"
	extents = _tmp32_;
#line 217 "../src/chess-window.vala"
	_tmp34_ = extents;
#line 217 "../src/chess-window.vala"
	if (max > _tmp34_.width) {
#line 217 "../src/chess-window.vala"
		_tmp33_ = max;
#line 1351 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp35_;
#line 217 "../src/chess-window.vala"
		_tmp35_ = extents;
#line 217 "../src/chess-window.vala"
		_tmp33_ = _tmp35_.width;
#line 1358 "chess-window.c"
	}
#line 217 "../src/chess-window.vala"
	max = _tmp33_;
#line 218 "../src/chess-window.vala"
	cairo_text_extents (c, "999∶99", &_tmp36_);
#line 218 "../src/chess-window.vala"
	extents = _tmp36_;
#line 219 "../src/chess-window.vala"
	_tmp38_ = extents;
#line 219 "../src/chess-window.vala"
	if (max > _tmp38_.width) {
#line 219 "../src/chess-window.vala"
		_tmp37_ = max;
#line 1372 "chess-window.c"
	} else {
		cairo_text_extents_t _tmp39_;
#line 219 "../src/chess-window.vala"
		_tmp39_ = extents;
#line 219 "../src/chess-window.vala"
		_tmp37_ = _tmp39_.width;
#line 1379 "chess-window.c"
	}
#line 219 "../src/chess-window.vala"
	max = _tmp37_;
#line 222 "../src/chess-window.vala"
	result = ((gint) ceil (max)) + 6;
#line 222 "../src/chess-window.vala"
	_vala_warn_if_fail (result > 0, "result > 0");
#line 222 "../src/chess-window.vala"
	return result;
#line 1389 "chess-window.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 225 "../src/chess-window.vala"
	return self ? cairo_reference (self) : NULL;
#line 1397 "chess-window.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 225 "../src/chess-window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 225 "../src/chess-window.vala"
	return _data2_;
#line 1407 "chess-window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 225 "../src/chess-window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1417 "chess-window.c"
		ChessWindow* self;
#line 225 "../src/chess-window.vala"
		self = _data2_->self;
#line 225 "../src/chess-window.vala"
		_g_object_unref0 (_data2_->widget);
#line 225 "../src/chess-window.vala"
		_cairo_destroy0 (_data2_->c);
#line 225 "../src/chess-window.vala"
		_g_object_unref0 (self);
#line 225 "../src/chess-window.vala"
		g_slice_free (Block2Data, _data2_);
#line 1429 "chess-window.c"
	}
}

static gboolean
___lambda42_ (Block2Data* _data2_)
{
	ChessWindow* self;
	gboolean result;
#line 235 "../src/chess-window.vala"
	self = _data2_->self;
#line 236 "../src/chess-window.vala"
	gtk_widget_set_size_request (_data2_->widget, chess_window_compute_time_label_width_request (self, _data2_->c), -1);
#line 237 "../src/chess-window.vala"
	gtk_widget_queue_draw (_data2_->widget);
#line 238 "../src/chess-window.vala"
	result = G_SOURCE_REMOVE;
#line 238 "../src/chess-window.vala"
	return result;
#line 1448 "chess-window.c"
}

static gboolean
____lambda42__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda42_ (self);
#line 235 "../src/chess-window.vala"
	return result;
#line 1458 "chess-window.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 252 "../src/chess-window.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1466 "chess-window.c"
}

static void
chess_window_draw_time (ChessWindow* self,
                        GtkWidget* widget,
                        cairo_t* c,
                        gint width,
                        gint height,
                        const gchar* text,
                        gdouble* fg,
                        gint fg_length1,
                        gdouble* bg,
                        gint bg_length1)
{
	Block2Data* _data2_;
	GtkWidget* _tmp0_;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble alpha = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	PangoContext* pango_context = NULL;
	PangoContext* _tmp7_;
	PangoContext* _tmp8_;
	cairo_font_options_t* _tmp9_;
	PangoLayout* layout = NULL;
	PangoContext* _tmp10_;
	PangoLayout* _tmp11_;
	PangoLayout* _tmp12_;
	PangoFontDescription* _tmp13_;
	PangoFontDescription* _tmp14_;
	PangoLayout* _tmp15_;
	PangoAttrList* attributes = NULL;
	PangoAttrList* _tmp16_;
	PangoAttrList* _tmp17_;
	PangoAttrFontFeatures* _tmp18_;
	PangoLayout* _tmp19_;
	PangoAttrList* _tmp20_;
	gint layout_width = 0;
	gint layout_height = 0;
	PangoLayout* _tmp21_;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	PangoLayout* _tmp27_;
#line 225 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/chess-window.vala"
	g_return_if_fail (widget != NULL);
#line 225 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 225 "../src/chess-window.vala"
	g_return_if_fail (text != NULL);
#line 225 "../src/chess-window.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 225 "../src/chess-window.vala"
	_data2_->_ref_count_ = 1;
#line 225 "../src/chess-window.vala"
	_data2_->self = g_object_ref (self);
#line 225 "../src/chess-window.vala"
	_tmp0_ = _g_object_ref0 (widget);
#line 225 "../src/chess-window.vala"
	_g_object_unref0 (_data2_->widget);
#line 225 "../src/chess-window.vala"
	_data2_->widget = _tmp0_;
#line 225 "../src/chess-window.vala"
	_tmp1_ = _cairo_reference0 (c);
#line 225 "../src/chess-window.vala"
	_cairo_destroy0 (_data2_->c);
#line 225 "../src/chess-window.vala"
	_data2_->c = _tmp1_;
#line 233 "../src/chess-window.vala"
	g_object_get (_data2_->widget, "width-request", &_tmp2_, NULL);
#line 233 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 233 "../src/chess-window.vala"
	if (_tmp3_ == -1) {
#line 235 "../src/chess-window.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda42__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 240 "../src/chess-window.vala"
		block2_data_unref (_data2_);
#line 240 "../src/chess-window.vala"
		_data2_ = NULL;
#line 240 "../src/chess-window.vala"
		return;
#line 1556 "chess-window.c"
	}
#line 243 "../src/chess-window.vala"
	alpha = 1.0;
#line 244 "../src/chess-window.vala"
	if ((gtk_widget_get_state_flags (_data2_->widget) & GTK_STATE_FLAG_INSENSITIVE) != 0) {
#line 245 "../src/chess-window.vala"
		alpha = 0.5;
#line 1564 "chess-window.c"
	}
#line 246 "../src/chess-window.vala"
	_tmp4_ = bg[0];
#line 246 "../src/chess-window.vala"
	_tmp5_ = bg[1];
#line 246 "../src/chess-window.vala"
	_tmp6_ = bg[2];
#line 246 "../src/chess-window.vala"
	cairo_set_source_rgba (_data2_->c, _tmp4_, _tmp5_, _tmp6_, alpha);
#line 247 "../src/chess-window.vala"
	cairo_paint (_data2_->c);
#line 249 "../src/chess-window.vala"
	_tmp7_ = pango_cairo_create_context (_data2_->c);
#line 249 "../src/chess-window.vala"
	pango_context = _tmp7_;
#line 250 "../src/chess-window.vala"
	_tmp8_ = pango_context;
#line 250 "../src/chess-window.vala"
	_tmp9_ = gtk_widget_get_font_options ((GtkWidget*) self);
#line 250 "../src/chess-window.vala"
	pango_cairo_context_set_font_options (_tmp8_, _tmp9_);
#line 251 "../src/chess-window.vala"
	_tmp10_ = pango_context;
#line 251 "../src/chess-window.vala"
	_tmp11_ = pango_layout_new (_tmp10_);
#line 251 "../src/chess-window.vala"
	layout = _tmp11_;
#line 252 "../src/chess-window.vala"
	_tmp12_ = layout;
#line 252 "../src/chess-window.vala"
	_tmp13_ = pango_font_description_from_string ("Sans Bold 14");
#line 252 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 252 "../src/chess-window.vala"
	pango_layout_set_font_description (_tmp12_, _tmp14_);
#line 252 "../src/chess-window.vala"
	__vala_PangoFontDescription_free0 (_tmp14_);
#line 253 "../src/chess-window.vala"
	_tmp15_ = layout;
#line 253 "../src/chess-window.vala"
	pango_layout_set_text (_tmp15_, text, -1);
#line 256 "../src/chess-window.vala"
	_tmp16_ = pango_attr_list_new ();
#line 256 "../src/chess-window.vala"
	attributes = _tmp16_;
#line 257 "../src/chess-window.vala"
	_tmp17_ = attributes;
#line 257 "../src/chess-window.vala"
	_tmp18_ = (PangoAttrFontFeatures*) pango_attr_font_features_new ("tnum=1");
#line 257 "../src/chess-window.vala"
	pango_attr_list_insert (_tmp17_, (PangoAttribute*) _tmp18_);
#line 258 "../src/chess-window.vala"
	_tmp19_ = layout;
#line 258 "../src/chess-window.vala"
	_tmp20_ = attributes;
#line 258 "../src/chess-window.vala"
	pango_layout_set_attributes (_tmp19_, _tmp20_);
#line 262 "../src/chess-window.vala"
	_tmp21_ = layout;
#line 262 "../src/chess-window.vala"
	pango_layout_get_size (_tmp21_, &_tmp22_, &_tmp23_);
#line 262 "../src/chess-window.vala"
	layout_width = _tmp22_;
#line 262 "../src/chess-window.vala"
	layout_height = _tmp23_;
#line 263 "../src/chess-window.vala"
	layout_width /= PANGO_SCALE;
#line 264 "../src/chess-window.vala"
	layout_height /= PANGO_SCALE;
#line 265 "../src/chess-window.vala"
	cairo_move_to (_data2_->c, (gdouble) ((gtk_widget_get_width (_data2_->widget) - layout_width) / 2), (gdouble) ((gtk_widget_get_height (_data2_->widget) - layout_height) / 2));
#line 267 "../src/chess-window.vala"
	_tmp24_ = fg[0];
#line 267 "../src/chess-window.vala"
	_tmp25_ = fg[1];
#line 267 "../src/chess-window.vala"
	_tmp26_ = fg[2];
#line 267 "../src/chess-window.vala"
	cairo_set_source_rgba (_data2_->c, _tmp24_, _tmp25_, _tmp26_, alpha);
#line 268 "../src/chess-window.vala"
	_tmp27_ = layout;
#line 268 "../src/chess-window.vala"
	pango_cairo_show_layout (_data2_->c, _tmp27_);
#line 225 "../src/chess-window.vala"
	_pango_attr_list_unref0 (attributes);
#line 225 "../src/chess-window.vala"
	_g_object_unref0 (layout);
#line 225 "../src/chess-window.vala"
	_g_object_unref0 (pango_context);
#line 225 "../src/chess-window.vala"
	block2_data_unref (_data2_);
#line 225 "../src/chess-window.vala"
	_data2_ = NULL;
#line 1658 "chess-window.c"
}

static gchar*
chess_window_make_clock_text (ChessWindow* self,
                              ChessClock* clock,
                              Color color)
{
	gint time = 0;
	gchar* result;
#line 271 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 271 "../src/chess-window.vala"
	_vala_return_val_if_fail (clock != NULL, "clock != null", NULL);
#line 275 "../src/chess-window.vala"
	if (color == COLOR_WHITE) {
#line 1674 "chess-window.c"
		gint _tmp0_;
		gint _tmp1_;
#line 276 "../src/chess-window.vala"
		_tmp0_ = chess_clock_get_white_remaining_seconds (clock);
#line 276 "../src/chess-window.vala"
		_tmp1_ = _tmp0_;
#line 276 "../src/chess-window.vala"
		time = _tmp1_;
#line 1683 "chess-window.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 278 "../src/chess-window.vala"
		_tmp2_ = chess_clock_get_black_remaining_seconds (clock);
#line 278 "../src/chess-window.vala"
		_tmp3_ = _tmp2_;
#line 278 "../src/chess-window.vala"
		time = _tmp3_;
#line 1693 "chess-window.c"
	}
#line 281 "../src/chess-window.vala"
	if (time >= 60) {
#line 1697 "chess-window.c"
		gchar* _tmp4_;
#line 282 "../src/chess-window.vala"
		_tmp4_ = g_strdup_printf ("%d∶\xE2\x80\x8E%02d", time / 60, time % 60);
#line 282 "../src/chess-window.vala"
		result = _tmp4_;
#line 282 "../src/chess-window.vala"
		return result;
#line 1705 "chess-window.c"
	} else {
		gchar* _tmp5_;
#line 284 "../src/chess-window.vala"
		_tmp5_ = g_strdup_printf ("∶\xE2\x80\x8E%02d", time);
#line 284 "../src/chess-window.vala"
		result = _tmp5_;
#line 284 "../src/chess-window.vala"
		return result;
#line 1714 "chess-window.c"
	}
}

static void
chess_window_draw_white_time_label (ChessWindow* self,
                                    GtkDrawingArea* drawing_area,
                                    cairo_t* c,
                                    gint width,
                                    gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessClock* _tmp4_;
	ChessClock* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
#line 287 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/chess-window.vala"
	g_return_if_fail (drawing_area != NULL);
#line 287 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 289 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 289 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 289 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 289 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 289 "../src/chess-window.vala"
	_tmp4_ = chess_game_get_clock (_tmp3_);
#line 289 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 289 "../src/chess-window.vala"
	_tmp6_ = chess_window_make_clock_text (self, _tmp5_, COLOR_WHITE);
#line 289 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 289 "../src/chess-window.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 289 "../src/chess-window.vala"
	_tmp8_[0] = 0.0;
#line 289 "../src/chess-window.vala"
	_tmp8_[1] = 0.0;
#line 289 "../src/chess-window.vala"
	_tmp8_[2] = 0.0;
#line 289 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 289 "../src/chess-window.vala"
	_tmp9__length1 = 3;
#line 289 "../src/chess-window.vala"
	_tmp10_ = g_new0 (gdouble, 3);
#line 289 "../src/chess-window.vala"
	_tmp10_[0] = 1.0;
#line 289 "../src/chess-window.vala"
	_tmp10_[1] = 1.0;
#line 289 "../src/chess-window.vala"
	_tmp10_[2] = 1.0;
#line 289 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 289 "../src/chess-window.vala"
	_tmp11__length1 = 3;
#line 289 "../src/chess-window.vala"
	chess_window_draw_time (self, (GtkWidget*) drawing_area, c, width, height, _tmp7_, _tmp9_, (gint) 3, _tmp11_, (gint) 3);
#line 289 "../src/chess-window.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 289 "../src/chess-window.vala"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 289 "../src/chess-window.vala"
	_g_free0 (_tmp7_);
#line 1793 "chess-window.c"
}

static void
chess_window_draw_black_time_label (ChessWindow* self,
                                    GtkDrawingArea* drawing_area,
                                    cairo_t* c,
                                    gint width,
                                    gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessClock* _tmp4_;
	ChessClock* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
#line 292 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/chess-window.vala"
	g_return_if_fail (drawing_area != NULL);
#line 292 "../src/chess-window.vala"
	g_return_if_fail (c != NULL);
#line 294 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 294 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 294 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 294 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 294 "../src/chess-window.vala"
	_tmp4_ = chess_game_get_clock (_tmp3_);
#line 294 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 294 "../src/chess-window.vala"
	_tmp6_ = chess_window_make_clock_text (self, _tmp5_, COLOR_BLACK);
#line 294 "../src/chess-window.vala"
	_tmp7_ = _tmp6_;
#line 294 "../src/chess-window.vala"
	_tmp8_ = g_new0 (gdouble, 3);
#line 294 "../src/chess-window.vala"
	_tmp8_[0] = 1.0;
#line 294 "../src/chess-window.vala"
	_tmp8_[1] = 1.0;
#line 294 "../src/chess-window.vala"
	_tmp8_[2] = 1.0;
#line 294 "../src/chess-window.vala"
	_tmp9_ = _tmp8_;
#line 294 "../src/chess-window.vala"
	_tmp9__length1 = 3;
#line 294 "../src/chess-window.vala"
	_tmp10_ = g_new0 (gdouble, 3);
#line 294 "../src/chess-window.vala"
	_tmp10_[0] = 0.0;
#line 294 "../src/chess-window.vala"
	_tmp10_[1] = 0.0;
#line 294 "../src/chess-window.vala"
	_tmp10_[2] = 0.0;
#line 294 "../src/chess-window.vala"
	_tmp11_ = _tmp10_;
#line 294 "../src/chess-window.vala"
	_tmp11__length1 = 3;
#line 294 "../src/chess-window.vala"
	chess_window_draw_time (self, (GtkWidget*) drawing_area, c, width, height, _tmp7_, _tmp9_, (gint) 3, _tmp11_, (gint) 3);
#line 294 "../src/chess-window.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 294 "../src/chess-window.vala"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 294 "../src/chess-window.vala"
	_g_free0 (_tmp7_);
#line 1871 "chess-window.c"
}

static void
chess_window_history_combo_changed_cb (ChessWindow* self,
                                       GtkComboBox* combo)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gint move_number = 0;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	ChessGame* _tmp7_;
	ChessGame* _tmp8_;
	ChessScene* _tmp13_;
	ChessScene* _tmp14_;
#line 298 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/chess-window.vala"
	g_return_if_fail (combo != NULL);
#line 301 "../src/chess-window.vala"
	_tmp1_ = gtk_combo_box_get_active_iter (combo, &_tmp0_);
#line 301 "../src/chess-window.vala"
	iter = _tmp0_;
#line 301 "../src/chess-window.vala"
	if (!_tmp1_) {
#line 302 "../src/chess-window.vala"
		return;
#line 1903 "chess-window.c"
	}
#line 304 "../src/chess-window.vala"
	_tmp2_ = gtk_combo_box_get_model (combo);
#line 304 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 304 "../src/chess-window.vala"
	_tmp4_ = iter;
#line 304 "../src/chess-window.vala"
	gtk_tree_model_get (_tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 304 "../src/chess-window.vala"
	move_number = _tmp5_;
#line 305 "../src/chess-window.vala"
	_tmp7_ = chess_window_get_game (self);
#line 305 "../src/chess-window.vala"
	_tmp8_ = _tmp7_;
#line 305 "../src/chess-window.vala"
	if (_tmp8_ == NULL) {
#line 305 "../src/chess-window.vala"
		_tmp6_ = TRUE;
#line 1923 "chess-window.c"
	} else {
		ChessGame* _tmp9_;
		ChessGame* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
#line 305 "../src/chess-window.vala"
		_tmp9_ = chess_window_get_game (self);
#line 305 "../src/chess-window.vala"
		_tmp10_ = _tmp9_;
#line 305 "../src/chess-window.vala"
		_tmp11_ = chess_game_get_n_moves (_tmp10_);
#line 305 "../src/chess-window.vala"
		_tmp12_ = _tmp11_;
#line 305 "../src/chess-window.vala"
		_tmp6_ = ((guint) move_number) == _tmp12_;
#line 1939 "chess-window.c"
	}
#line 305 "../src/chess-window.vala"
	if (_tmp6_) {
#line 306 "../src/chess-window.vala"
		move_number = -1;
#line 1945 "chess-window.c"
	}
#line 307 "../src/chess-window.vala"
	_tmp13_ = chess_window_get_scene (self);
#line 307 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 307 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp14_, move_number);
#line 1953 "chess-window.c"
}

static void
_chess_window_history_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                              gpointer self)
{
#line 14 "../src/chess-window.vala"
	chess_window_history_combo_changed_cb ((ChessWindow*) self, _sender);
#line 1962 "chess-window.c"
}

void
chess_window_set_move_text (ChessWindow* self,
                            GtkTreeIter* iter,
                            ChessMove* move)
{
#line 313 "../src/chess-window.vala"
	static const gchar* human_descriptions[72] = {N_ ("White pawn moves from %1$s to %2$s"), N_ ("White pawn at %1$s takes the black pawn at %2$s"), N_ ("White pawn at %1$s takes the black rook at %2$s"), N_ ("White pawn at %1$s takes the black knight at %2$s"), N_ ("White pawn at %1$s takes the black bishop at %2$s"), N_ ("White pawn at %1$s takes the black queen at %2$s"), N_ ("White rook moves from %1$s to %2$s"), N_ ("White rook at %1$s takes the black pawn at %2$s"), N_ ("White rook at %1$s takes the black rook at %2$s"), N_ ("White rook at %1$s takes the black knight at %2$s"), N_ ("White rook at %1$s takes the black bishop at %2$s"), N_ ("White rook at %1$s takes the black queen at %2$s"), N_ ("White knight moves from %1$s to %2$s"), N_ ("White knight at %1$s takes the black pawn at %2$s"), N_ ("White knight at %1$s takes the black rook at %2$s"), N_ ("White knight at %1$s takes the black knight at %2$s"), N_ ("White knight at %1$s takes the black bishop at %2$s"), N_ ("White knight at %1$s takes the black queen at %2$s"), N_ ("White bishop moves from %1$s to %2$s"), N_ ("White bishop at %1$s takes the black pawn at %2$s"), N_ ("White bishop at %1$s takes the black rook at %2$s"), N_ ("White bishop at %1$s takes the black knight at %2$s"), N_ ("White bishop at %1$s takes the black bishop at %2$s"), N_ ("White bishop at %1$s takes the black queen at %2$s"), N_ ("White queen moves from %1$s to %2$s"), N_ ("White queen at %1$s takes the black pawn at %2$s"), N_ ("White queen at %1$s takes the black rook at %2$s"), N_ ("White queen at %1$s takes the black knight at %2$s"), N_ ("White queen at %1$s takes the black bishop at %2$s"), N_ ("White queen at %1$s takes the black queen at %2$s"), N_ ("White king moves from %1$s to %2$s"), N_ ("White king at %1$s takes the black pawn at %2$s"), N_ ("White king at %1$s takes the black rook at %2$s"), N_ ("White king at %1$s takes the black knight at %2$s"), N_ ("White king at %1$s takes the black bishop at %2$s"), N_ ("White king at %1$s takes the black queen at %2$s"), N_ ("Black pawn moves from %1$s to %2$s"), N_ ("Black pawn at %1$s takes the white pawn at %2$s"), N_ ("Black pawn at %1$s takes the white rook at %2$s"), N_ ("Black pawn at %1$s takes the white knight at %2$s"), N_ ("Black pawn at %1$s takes the white bishop at %2$s"), N_ ("Black pawn at %1$s takes the white queen at %2$s"), N_ ("Black rook moves from %1$s to %2$s"), N_ ("Black rook at %1$s takes the white pawn at %2$s"), N_ ("Black rook at %1$s takes the white rook at %2$s"), N_ ("Black rook at %1$s takes the white knight at %2$s"), N_ ("Black rook at %1$s takes the white bishop at %2$s"), N_ ("Black rook at %1$s takes the white queen at %2$s"), N_ ("Black knight moves from %1$s to %2$s"), N_ ("Black knight at %1$s takes the white pawn at %2$s"), N_ ("Black knight at %1$s takes the white rook at %2$s"), N_ ("Black knight at %1$s takes the white knight at %2$s"), N_ ("Black knight at %1$s takes the white bishop at %2$s"), N_ ("Black knight at %1$s takes the white queen at %2$s"), N_ ("Black bishop moves from %1$s to %2$s"), N_ ("Black bishop at %1$s takes the white pawn at %2$s"), N_ ("Black bishop at %1$s takes the white rook at %2$s"), N_ ("Black bishop at %1$s takes the white knight at %2$s"), N_ ("Black bishop at %1$s takes the white bishop at %2$s"), N_ ("Black bishop at %1$s takes the white queen at %2$s"), N_ ("Black queen moves from %1$s to %2$s"), N_ ("Black queen at %1$s takes the white pawn at %2$s"), N_ ("Black queen at %1$s takes the white rook at %2$s"), N_ ("Black queen at %1$s takes the white knight at %2$s"), N_ ("Black queen at %1$s takes the white bishop at %2$s"), N_ ("Black queen at %1$s takes the white queen at %2$s"), N_ ("Black king moves from %1$s to %2$s"), N_ ("Black king at %1$s takes the white pawn at %2$s"), N_ ("Black king at %1$s takes the white rook at %2$s"), N_ ("Black king at %1$s takes the white knight at %2$s"), N_ ("Black king at %1$s takes the white bishop at %2$s"), N_ ("Black king at %1$s takes the white queen at %2$s")};
#line 1972 "chess-window.c"
	gchar* move_text = NULL;
	gchar* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 459 "../src/chess-window.vala"
	static GQuark _tmp6_label0 = 0;
#line 459 "../src/chess-window.vala"
	static GQuark _tmp6_label1 = 0;
#line 459 "../src/chess-window.vala"
	static GQuark _tmp6_label2 = 0;
#line 1987 "chess-window.c"
	GtkListStore* model = NULL;
	GtkComboBox* _tmp35_;
	GtkTreeModel* _tmp36_;
	GtkTreeModel* _tmp37_;
	GtkListStore* _tmp38_;
	gchar _tmp39_ = '\0';
	gchar* label = NULL;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GtkListStore* _tmp42_;
	GtkTreeIter _tmp43_;
#line 310 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/chess-window.vala"
	g_return_if_fail (iter != NULL);
#line 310 "../src/chess-window.vala"
	g_return_if_fail (move != NULL);
#line 458 "../src/chess-window.vala"
	_tmp0_ = g_strdup ("");
#line 458 "../src/chess-window.vala"
	move_text = _tmp0_;
#line 459 "../src/chess-window.vala"
	_tmp1_ = chess_window_get_scene (self);
#line 459 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 459 "../src/chess-window.vala"
	_tmp3_ = chess_scene_get_move_format (_tmp2_);
#line 459 "../src/chess-window.vala"
	_tmp4_ = _tmp3_;
#line 459 "../src/chess-window.vala"
	_tmp5_ = _tmp4_;
#line 459 "../src/chess-window.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 459 "../src/chess-window.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("human")))) {
#line 459 "../src/chess-window.vala"
		switch (0) {
#line 2025 "chess-window.c"
			default:
			{
				ChessPiece* _tmp8_;
#line 462 "../src/chess-window.vala"
				_tmp8_ = move->castling_rook;
#line 462 "../src/chess-window.vala"
				if (_tmp8_ != NULL) {
#line 2033 "chess-window.c"
					gboolean _tmp9_ = FALSE;
#line 464 "../src/chess-window.vala"
					if (move->f0 < move->f1) {
#line 464 "../src/chess-window.vala"
						_tmp9_ = move->r0 == 0;
#line 2039 "chess-window.c"
					} else {
#line 464 "../src/chess-window.vala"
						_tmp9_ = FALSE;
#line 2043 "chess-window.c"
					}
#line 464 "../src/chess-window.vala"
					if (_tmp9_) {
#line 2047 "chess-window.c"
						gchar* _tmp10_;
#line 465 "../src/chess-window.vala"
						_tmp10_ = g_strdup (_ ("White castles kingside"));
#line 465 "../src/chess-window.vala"
						_g_free0 (move_text);
#line 465 "../src/chess-window.vala"
						move_text = _tmp10_;
#line 2055 "chess-window.c"
					} else {
						gboolean _tmp11_ = FALSE;
#line 466 "../src/chess-window.vala"
						if (move->f1 < move->f0) {
#line 466 "../src/chess-window.vala"
							_tmp11_ = move->r0 == 0;
#line 2062 "chess-window.c"
						} else {
#line 466 "../src/chess-window.vala"
							_tmp11_ = FALSE;
#line 2066 "chess-window.c"
						}
#line 466 "../src/chess-window.vala"
						if (_tmp11_) {
#line 2070 "chess-window.c"
							gchar* _tmp12_;
#line 467 "../src/chess-window.vala"
							_tmp12_ = g_strdup (_ ("White castles queenside"));
#line 467 "../src/chess-window.vala"
							_g_free0 (move_text);
#line 467 "../src/chess-window.vala"
							move_text = _tmp12_;
#line 2078 "chess-window.c"
						} else {
							gboolean _tmp13_ = FALSE;
#line 468 "../src/chess-window.vala"
							if (move->f0 < move->f1) {
#line 468 "../src/chess-window.vala"
								_tmp13_ = move->r0 == 7;
#line 2085 "chess-window.c"
							} else {
#line 468 "../src/chess-window.vala"
								_tmp13_ = FALSE;
#line 2089 "chess-window.c"
							}
#line 468 "../src/chess-window.vala"
							if (_tmp13_) {
#line 2093 "chess-window.c"
								gchar* _tmp14_;
#line 469 "../src/chess-window.vala"
								_tmp14_ = g_strdup (_ ("Black castles kingside"));
#line 469 "../src/chess-window.vala"
								_g_free0 (move_text);
#line 469 "../src/chess-window.vala"
								move_text = _tmp14_;
#line 2101 "chess-window.c"
							} else {
								gboolean _tmp15_ = FALSE;
#line 470 "../src/chess-window.vala"
								if (move->f1 < move->f0) {
#line 470 "../src/chess-window.vala"
									_tmp15_ = move->r0 == 7;
#line 2108 "chess-window.c"
								} else {
#line 470 "../src/chess-window.vala"
									_tmp15_ = FALSE;
#line 2112 "chess-window.c"
								}
#line 470 "../src/chess-window.vala"
								if (_tmp15_) {
#line 2116 "chess-window.c"
									gchar* _tmp16_;
#line 471 "../src/chess-window.vala"
									_tmp16_ = g_strdup (_ ("Black castles queenside"));
#line 471 "../src/chess-window.vala"
									_g_free0 (move_text);
#line 471 "../src/chess-window.vala"
									move_text = _tmp16_;
#line 2124 "chess-window.c"
								} else {
#line 473 "../src/chess-window.vala"
									g_assert_not_reached ();
#line 2128 "chess-window.c"
								}
							}
						}
					}
				} else {
					gint index = 0;
					ChessPiece* _tmp17_;
					ChessPiece* _tmp19_;
					ChessPiece* _tmp20_;
					ChessPlayer* _tmp21_;
					gchar* start = NULL;
					gchar* _tmp22_;
					gchar* end = NULL;
					gchar* _tmp23_;
					gchar* template = NULL;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					gchar* _tmp31_;
#line 478 "../src/chess-window.vala"
					_tmp17_ = move->victim;
#line 478 "../src/chess-window.vala"
					if (_tmp17_ == NULL) {
#line 479 "../src/chess-window.vala"
						index = 0;
#line 2156 "chess-window.c"
					} else {
						ChessPiece* _tmp18_;
#line 481 "../src/chess-window.vala"
						_tmp18_ = move->victim;
#line 481 "../src/chess-window.vala"
						index = (gint) (_tmp18_->type + 1);
#line 2163 "chess-window.c"
					}
#line 482 "../src/chess-window.vala"
					_tmp19_ = move->piece;
#line 482 "../src/chess-window.vala"
					index += (gint) (_tmp19_->type * 6);
#line 483 "../src/chess-window.vala"
					_tmp20_ = move->piece;
#line 483 "../src/chess-window.vala"
					_tmp21_ = _tmp20_->player;
#line 483 "../src/chess-window.vala"
					if (_tmp21_->color == COLOR_BLACK) {
#line 484 "../src/chess-window.vala"
						index += 36;
#line 2177 "chess-window.c"
					}
#line 486 "../src/chess-window.vala"
					_tmp22_ = g_strdup_printf ("%c%d", 'a' + move->f0, move->r0 + 1);
#line 486 "../src/chess-window.vala"
					start = _tmp22_;
#line 487 "../src/chess-window.vala"
					_tmp23_ = g_strdup_printf ("%c%d", 'a' + move->f1, move->r1 + 1);
#line 487 "../src/chess-window.vala"
					end = _tmp23_;
#line 488 "../src/chess-window.vala"
					_tmp24_ = human_descriptions[index];
#line 488 "../src/chess-window.vala"
					_tmp25_ = g_strdup (_ (_tmp24_));
#line 488 "../src/chess-window.vala"
					template = _tmp25_;
#line 489 "../src/chess-window.vala"
					if (move->en_passant) {
#line 491 "../src/chess-window.vala"
						if (move->r0 < move->r1) {
#line 2197 "chess-window.c"
							gchar* _tmp26_;
#line 493 "../src/chess-window.vala"
							_tmp26_ = g_strdup (_ ("White pawn at %1$s takes the black pawn at %2$s en passant"));
#line 493 "../src/chess-window.vala"
							_g_free0 (template);
#line 493 "../src/chess-window.vala"
							template = _tmp26_;
#line 2205 "chess-window.c"
						} else {
							gchar* _tmp27_;
#line 497 "../src/chess-window.vala"
							_tmp27_ = g_strdup (_ ("Black pawn at %1$s takes white pawn at %2$s en passant"));
#line 497 "../src/chess-window.vala"
							_g_free0 (template);
#line 497 "../src/chess-window.vala"
							template = _tmp27_;
#line 2214 "chess-window.c"
						}
					}
#line 500 "../src/chess-window.vala"
					_tmp28_ = template;
#line 500 "../src/chess-window.vala"
					_tmp29_ = start;
#line 500 "../src/chess-window.vala"
					_tmp30_ = end;
#line 500 "../src/chess-window.vala"
					_tmp31_ = g_strdup_printf (_tmp28_, _tmp29_, _tmp30_);
#line 500 "../src/chess-window.vala"
					_g_free0 (move_text);
#line 500 "../src/chess-window.vala"
					move_text = _tmp31_;
#line 462 "../src/chess-window.vala"
					_g_free0 (template);
#line 462 "../src/chess-window.vala"
					_g_free0 (end);
#line 462 "../src/chess-window.vala"
					_g_free0 (start);
#line 2235 "chess-window.c"
				}
#line 502 "../src/chess-window.vala"
				break;
#line 2239 "chess-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("san")))) {
#line 459 "../src/chess-window.vala"
		switch (0) {
#line 2245 "chess-window.c"
			default:
			{
				gchar* _tmp32_;
#line 505 "../src/chess-window.vala"
				_tmp32_ = chess_move_get_san (move);
#line 505 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 505 "../src/chess-window.vala"
				move_text = _tmp32_;
#line 506 "../src/chess-window.vala"
				break;
#line 2257 "chess-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("fan")))) {
#line 459 "../src/chess-window.vala"
		switch (0) {
#line 2263 "chess-window.c"
			default:
			{
				gchar* _tmp33_;
#line 509 "../src/chess-window.vala"
				_tmp33_ = chess_move_get_fan (move);
#line 509 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 509 "../src/chess-window.vala"
				move_text = _tmp33_;
#line 510 "../src/chess-window.vala"
				break;
#line 2275 "chess-window.c"
			}
		}
	} else {
#line 459 "../src/chess-window.vala"
		switch (0) {
#line 2281 "chess-window.c"
			default:
			{
				gchar* _tmp34_;
#line 514 "../src/chess-window.vala"
				_tmp34_ = chess_move_get_lan (move);
#line 514 "../src/chess-window.vala"
				_g_free0 (move_text);
#line 514 "../src/chess-window.vala"
				move_text = _tmp34_;
#line 515 "../src/chess-window.vala"
				break;
#line 2293 "chess-window.c"
			}
		}
	}
#line 518 "../src/chess-window.vala"
	_tmp35_ = self->priv->history_combo;
#line 518 "../src/chess-window.vala"
	_tmp36_ = gtk_combo_box_get_model (_tmp35_);
#line 518 "../src/chess-window.vala"
	_tmp37_ = _tmp36_;
#line 518 "../src/chess-window.vala"
	_tmp38_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_list_store_get_type (), GtkListStore));
#line 518 "../src/chess-window.vala"
	model = _tmp38_;
#line 519 "../src/chess-window.vala"
	if ((move->number % 2) == 0) {
#line 519 "../src/chess-window.vala"
		_tmp39_ = 'b';
#line 2311 "chess-window.c"
	} else {
#line 519 "../src/chess-window.vala"
		_tmp39_ = 'a';
#line 2315 "chess-window.c"
	}
#line 519 "../src/chess-window.vala"
	_tmp40_ = move_text;
#line 519 "../src/chess-window.vala"
	_tmp41_ = g_strdup_printf ("%u%c. %s", (guint) ((move->number + 1) / 2), (gint) _tmp39_, _tmp40_);
#line 519 "../src/chess-window.vala"
	label = _tmp41_;
#line 520 "../src/chess-window.vala"
	_tmp42_ = model;
#line 520 "../src/chess-window.vala"
	_tmp43_ = *iter;
#line 520 "../src/chess-window.vala"
	gtk_list_store_set (_tmp42_, &_tmp43_, 0, label, -1, -1);
#line 310 "../src/chess-window.vala"
	_g_free0 (label);
#line 310 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 310 "../src/chess-window.vala"
	_g_free0 (move_text);
#line 2335 "chess-window.c"
}

static void
___lambda31_ (ChessWindow* self)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 540 "../src/chess-window.vala"
	_tmp0_ = self->priv->white_time_label;
#line 540 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 541 "../src/chess-window.vala"
	_tmp1_ = self->priv->black_time_label;
#line 541 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 2351 "chess-window.c"
}

static void
____lambda31__chess_clock_tick (ChessClock* _sender,
                                gpointer self)
{
#line 539 "../src/chess-window.vala"
	___lambda31_ ((ChessWindow*) self);
#line 2360 "chess-window.c"
}

void
chess_window_start_game (ChessWindow* self)
{
	GtkListStore* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* _tmp3_;
	GtkListStore* _tmp4_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GtkComboBox* _tmp9_;
	GtkTreeIter _tmp10_;
	GtkDrawingArea* _tmp11_;
	GtkDrawingArea* _tmp12_;
	ChessGame* _tmp13_;
	ChessGame* _tmp14_;
	ChessClock* _tmp15_;
	ChessClock* _tmp16_;
#line 523 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 525 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_combo;
#line 525 "../src/chess-window.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 525 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 525 "../src/chess-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_list_store_get_type (), GtkListStore));
#line 525 "../src/chess-window.vala"
	model = _tmp3_;
#line 526 "../src/chess-window.vala"
	_tmp4_ = model;
#line 526 "../src/chess-window.vala"
	gtk_list_store_clear (_tmp4_);
#line 528 "../src/chess-window.vala"
	_tmp5_ = model;
#line 528 "../src/chess-window.vala"
	gtk_list_store_append (_tmp5_, &_tmp6_);
#line 528 "../src/chess-window.vala"
	iter = _tmp6_;
#line 529 "../src/chess-window.vala"
	_tmp7_ = model;
#line 529 "../src/chess-window.vala"
	_tmp8_ = iter;
#line 529 "../src/chess-window.vala"
	gtk_list_store_set (_tmp7_, &_tmp8_, 0, _ ("Game Start"), 1, 0, -1, -1);
#line 532 "../src/chess-window.vala"
	_tmp9_ = self->priv->history_combo;
#line 532 "../src/chess-window.vala"
	_tmp10_ = iter;
#line 532 "../src/chess-window.vala"
	gtk_combo_box_set_active_iter (_tmp9_, &_tmp10_);
#line 534 "../src/chess-window.vala"
	_tmp11_ = self->priv->white_time_label;
#line 534 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp11_);
#line 535 "../src/chess-window.vala"
	_tmp12_ = self->priv->black_time_label;
#line 535 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp12_);
#line 537 "../src/chess-window.vala"
	_tmp13_ = chess_window_get_game (self);
#line 537 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 537 "../src/chess-window.vala"
	_tmp15_ = chess_game_get_clock (_tmp14_);
#line 537 "../src/chess-window.vala"
	_tmp16_ = _tmp15_;
#line 537 "../src/chess-window.vala"
	if (_tmp16_ != NULL) {
#line 2437 "chess-window.c"
		ChessGame* _tmp17_;
		ChessGame* _tmp18_;
		ChessClock* _tmp19_;
		ChessClock* _tmp20_;
#line 539 "../src/chess-window.vala"
		_tmp17_ = chess_window_get_game (self);
#line 539 "../src/chess-window.vala"
		_tmp18_ = _tmp17_;
#line 539 "../src/chess-window.vala"
		_tmp19_ = chess_game_get_clock (_tmp18_);
#line 539 "../src/chess-window.vala"
		_tmp20_ = _tmp19_;
#line 539 "../src/chess-window.vala"
		g_signal_connect_object (_tmp20_, "tick", (GCallback) ____lambda31__chess_clock_tick, self, 0);
#line 2452 "chess-window.c"
	}
#line 523 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 2456 "chess-window.c"
}

void
chess_window_move (ChessWindow* self,
                   ChessMove* m)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	GtkListStore* model = NULL;
	GtkComboBox* _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkTreeIter _tmp10_;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
#line 546 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 546 "../src/chess-window.vala"
	g_return_if_fail (m != NULL);
#line 549 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 549 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 549 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp1_, -1);
#line 551 "../src/chess-window.vala"
	_tmp2_ = self->priv->history_combo;
#line 551 "../src/chess-window.vala"
	_tmp3_ = gtk_combo_box_get_model (_tmp2_);
#line 551 "../src/chess-window.vala"
	_tmp4_ = _tmp3_;
#line 551 "../src/chess-window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_list_store_get_type (), GtkListStore));
#line 551 "../src/chess-window.vala"
	model = _tmp5_;
#line 553 "../src/chess-window.vala"
	_tmp6_ = model;
#line 553 "../src/chess-window.vala"
	gtk_list_store_append (_tmp6_, &_tmp7_);
#line 553 "../src/chess-window.vala"
	iter = _tmp7_;
#line 554 "../src/chess-window.vala"
	_tmp8_ = model;
#line 554 "../src/chess-window.vala"
	_tmp9_ = iter;
#line 554 "../src/chess-window.vala"
	gtk_list_store_set (_tmp8_, &_tmp9_, 1, m->number, -1, -1);
#line 555 "../src/chess-window.vala"
	_tmp10_ = iter;
#line 555 "../src/chess-window.vala"
	chess_window_set_move_text (self, &_tmp10_, m);
#line 558 "../src/chess-window.vala"
	_tmp11_ = chess_window_get_game (self);
#line 558 "../src/chess-window.vala"
	_tmp12_ = _tmp11_;
#line 558 "../src/chess-window.vala"
	_tmp13_ = chess_game_get_n_moves (_tmp12_);
#line 558 "../src/chess-window.vala"
	_tmp14_ = _tmp13_;
#line 558 "../src/chess-window.vala"
	if (((guint) m->number) == _tmp14_) {
#line 2526 "chess-window.c"
		GtkComboBox* _tmp15_;
		GtkTreeIter _tmp16_;
#line 559 "../src/chess-window.vala"
		_tmp15_ = self->priv->history_combo;
#line 559 "../src/chess-window.vala"
		_tmp16_ = iter;
#line 559 "../src/chess-window.vala"
		gtk_combo_box_set_active_iter (_tmp15_, &_tmp16_);
#line 2535 "chess-window.c"
	}
#line 546 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 2539 "chess-window.c"
}

void
chess_window_undo (ChessWindow* self)
{
	GtkListStore* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp4_ = {0};
	ChessScene* _tmp5_;
	ChessScene* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkComboBox* _tmp8_;
	GtkTreeIter _tmp9_;
	ChessView* _tmp10_;
#line 562 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 565 "../src/chess-window.vala"
	_tmp0_ = self->priv->history_combo;
#line 565 "../src/chess-window.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 565 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 565 "../src/chess-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_list_store_get_type (), GtkListStore));
#line 565 "../src/chess-window.vala"
	model = _tmp3_;
#line 567 "../src/chess-window.vala"
	gtk_tree_model_iter_nth_child ((GtkTreeModel*) model, &_tmp4_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) model, NULL) - 1);
#line 567 "../src/chess-window.vala"
	iter = _tmp4_;
#line 568 "../src/chess-window.vala"
	gtk_list_store_remove (model, &iter);
#line 571 "../src/chess-window.vala"
	_tmp5_ = chess_window_get_scene (self);
#line 571 "../src/chess-window.vala"
	_tmp6_ = _tmp5_;
#line 571 "../src/chess-window.vala"
	chess_scene_set_move_number (_tmp6_, -1);
#line 574 "../src/chess-window.vala"
	gtk_tree_model_iter_nth_child ((GtkTreeModel*) model, &_tmp7_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) model, NULL) - 1);
#line 574 "../src/chess-window.vala"
	iter = _tmp7_;
#line 575 "../src/chess-window.vala"
	_tmp8_ = self->priv->history_combo;
#line 575 "../src/chess-window.vala"
	_tmp9_ = iter;
#line 575 "../src/chess-window.vala"
	gtk_combo_box_set_active_iter (_tmp8_, &_tmp9_);
#line 576 "../src/chess-window.vala"
	_tmp10_ = self->priv->_view;
#line 576 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp10_);
#line 562 "../src/chess-window.vala"
	_g_object_unref0 (model);
#line 2598 "chess-window.c"
}

void
chess_window_end_game (ChessWindow* self)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 579 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 581 "../src/chess-window.vala"
	_tmp0_ = self->priv->white_time_label;
#line 581 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 582 "../src/chess-window.vala"
	_tmp1_ = self->priv->black_time_label;
#line 582 "../src/chess-window.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp1_);
#line 2616 "chess-window.c"
}

ChessWindowLayoutMode
chess_window_get_layout_mode (ChessWindow* self)
{
	ChessWindowLayoutMode result;
#line 24 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/chess-window.vala"
	result = self->priv->_layout_mode;
#line 24 "../src/chess-window.vala"
	return result;
#line 2629 "chess-window.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 26 "../src/chess-window.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 26 "../src/chess-window.vala"
	return _data3_;
#line 2639 "chess-window.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 26 "../src/chess-window.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2649 "chess-window.c"
		ChessWindow* self;
#line 26 "../src/chess-window.vala"
		self = _data3_->self;
#line 26 "../src/chess-window.vala"
		_g_object_unref0 (self);
#line 26 "../src/chess-window.vala"
		g_slice_free (Block3Data, _data3_);
#line 2657 "chess-window.c"
	}
}

static gboolean
_chess_window_layout_mode___lambda39_ (Block3Data* _data3_)
{
	ChessWindow* self;
	GtkOrientation _tmp0_ = 0;
	GtkBox* _tmp1_;
	gboolean result;
#line 33 "../src/chess-window.vala"
	self = _data3_->self;
#line 34 "../src/chess-window.vala"
	if (_data3_->value == CHESS_WINDOW_LAYOUT_MODE_NORMAL) {
#line 34 "../src/chess-window.vala"
		_tmp0_ = GTK_ORIENTATION_HORIZONTAL;
#line 2674 "chess-window.c"
	} else {
#line 34 "../src/chess-window.vala"
		_tmp0_ = GTK_ORIENTATION_VERTICAL;
#line 2678 "chess-window.c"
	}
#line 34 "../src/chess-window.vala"
	_tmp1_ = self->priv->navigation_box;
#line 34 "../src/chess-window.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp1_, _tmp0_);
#line 35 "../src/chess-window.vala"
	result = G_SOURCE_REMOVE;
#line 35 "../src/chess-window.vala"
	return result;
#line 2688 "chess-window.c"
}

static gboolean
__chess_window_layout_mode___lambda39__gsource_func (gpointer self)
{
	gboolean result;
	result = _chess_window_layout_mode___lambda39_ (self);
#line 33 "../src/chess-window.vala"
	return result;
#line 2698 "chess-window.c"
}

static void
chess_window_set_layout_mode (ChessWindow* self,
                              ChessWindowLayoutMode value)
{
	Block3Data* _data3_;
#line 26 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/chess-window.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 26 "../src/chess-window.vala"
	_data3_->_ref_count_ = 1;
#line 26 "../src/chess-window.vala"
	_data3_->self = g_object_ref (self);
#line 26 "../src/chess-window.vala"
	_data3_->value = value;
#line 28 "../src/chess-window.vala"
	if (self->priv->_layout_mode == _data3_->value) {
#line 29 "../src/chess-window.vala"
		block3_data_unref (_data3_);
#line 29 "../src/chess-window.vala"
		_data3_ = NULL;
#line 29 "../src/chess-window.vala"
		return;
#line 2724 "chess-window.c"
	}
#line 31 "../src/chess-window.vala"
	self->priv->_layout_mode = _data3_->value;
#line 33 "../src/chess-window.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __chess_window_layout_mode___lambda39__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 26 "../src/chess-window.vala"
	block3_data_unref (_data3_);
#line 26 "../src/chess-window.vala"
	_data3_ = NULL;
#line 26 "../src/chess-window.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_window_properties[CHESS_WINDOW_LAYOUT_MODE_PROPERTY]);
#line 2736 "chess-window.c"
}

ChessView*
chess_window_get_view (ChessWindow* self)
{
	ChessView* result;
	ChessView* _tmp0_;
#line 42 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/chess-window.vala"
	_tmp0_ = self->priv->_view;
#line 42 "../src/chess-window.vala"
	result = _tmp0_;
#line 42 "../src/chess-window.vala"
	return result;
#line 2752 "chess-window.c"
}

static void
chess_window_set_view (ChessWindow* self,
                       ChessView* value)
{
	ChessView* old_value;
#line 42 "../src/chess-window.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/chess-window.vala"
	old_value = chess_window_get_view (self);
#line 42 "../src/chess-window.vala"
	if (old_value != value) {
#line 2766 "chess-window.c"
		ChessView* _tmp0_;
#line 42 "../src/chess-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/chess-window.vala"
		_g_object_unref0 (self->priv->_view);
#line 42 "../src/chess-window.vala"
		self->priv->_view = _tmp0_;
#line 42 "../src/chess-window.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_window_properties[CHESS_WINDOW_VIEW_PROPERTY]);
#line 2776 "chess-window.c"
	}
}

ChessScene*
chess_window_get_scene (ChessWindow* self)
{
	ChessScene* result;
	ChessView* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
#line 47 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/chess-window.vala"
	_tmp0_ = self->priv->_view;
#line 47 "../src/chess-window.vala"
	_tmp1_ = chess_view_get_scene (_tmp0_);
#line 47 "../src/chess-window.vala"
	_tmp2_ = _tmp1_;
#line 47 "../src/chess-window.vala"
	result = _tmp2_;
#line 47 "../src/chess-window.vala"
	return result;
#line 2799 "chess-window.c"
}

ChessGame*
chess_window_get_game (ChessWindow* self)
{
	ChessGame* result;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
#line 52 "../src/chess-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/chess-window.vala"
	_tmp0_ = chess_window_get_scene (self);
#line 52 "../src/chess-window.vala"
	_tmp1_ = _tmp0_;
#line 52 "../src/chess-window.vala"
	_tmp2_ = chess_scene_get_game (_tmp1_);
#line 52 "../src/chess-window.vala"
	_tmp3_ = _tmp2_;
#line 52 "../src/chess-window.vala"
	result = _tmp3_;
#line 52 "../src/chess-window.vala"
	return result;
#line 2824 "chess-window.c"
}

static void
chess_window_class_init (ChessWindowClass * klass,
                         gpointer klass_data)
{
#line 14 "../src/chess-window.vala"
	chess_window_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/chess-window.vala"
	g_type_class_adjust_private_offset (klass, &ChessWindow_private_offset);
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_window_get_property;
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_window_set_property;
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_window_finalize;
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_LAYOUT_MODE_PROPERTY, chess_window_properties[CHESS_WINDOW_LAYOUT_MODE_PROPERTY] = g_param_spec_enum ("layout-mode", "layout-mode", "layout-mode", CHESS_WINDOW_TYPE_LAYOUT_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_VIEW_PROPERTY, chess_window_properties[CHESS_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_CHESS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_SCENE_PROPERTY, chess_window_properties[CHESS_WINDOW_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_WINDOW_GAME_PROPERTY, chess_window_properties[CHESS_WINDOW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_CHESS_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Chess/ui/chess-window.ui");
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, toast_overlay));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_resume_button", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, pause_resume_button));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "navigation_box", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, navigation_box));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "history_combo", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, history_combo));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, clock_box));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "white_time_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, white_time_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "black_time_label", FALSE, ChessWindow_private_offset + G_STRUCT_OFFSET (ChessWindowPrivate, black_time_label));
#line 14 "../src/chess-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "history_combo_changed_cb", G_CALLBACK(_chess_window_history_combo_changed_cb_gtk_combo_box_changed));
#line 2867 "chess-window.c"
}

static void
chess_window_instance_init (ChessWindow * self,
                            gpointer klass)
{
#line 14 "../src/chess-window.vala"
	self->priv = chess_window_get_instance_private (self);
#line 21 "../src/chess-window.vala"
	self->priv->_layout_mode = CHESS_WINDOW_LAYOUT_MODE_NORMAL;
#line 14 "../src/chess-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2880 "chess-window.c"
}

static void
chess_window_finalize (GObject * obj)
{
	ChessWindow * self;
#line 14 "../src/chess-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_WINDOW, ChessWindow);
#line 40 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->_view);
#line 55 "../src/chess-window.vala"
	_g_object_unref0 (self->priv->app);
#line 14 "../src/chess-window.vala"
	G_OBJECT_CLASS (chess_window_parent_class)->finalize (obj);
#line 2895 "chess-window.c"
}

static GType
chess_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessWindow), 0, (GInstanceInitFunc) chess_window_instance_init, NULL };
	GType chess_window_type_id;
	chess_window_type_id = g_type_register_static (adw_application_window_get_type (), "ChessWindow", &g_define_type_info, 0);
	ChessWindow_private_offset = g_type_add_instance_private (chess_window_type_id, sizeof (ChessWindowPrivate));
	return chess_window_type_id;
}

GType
chess_window_get_type (void)
{
	static volatile gsize chess_window_type_id__once = 0;
	if (g_once_init_enter (&chess_window_type_id__once)) {
		GType chess_window_type_id;
		chess_window_type_id = chess_window_get_type_once ();
		g_once_init_leave (&chess_window_type_id__once, chess_window_type_id);
	}
	return chess_window_type_id__once;
}

static void
_vala_chess_window_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ChessWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_WINDOW, ChessWindow);
#line 14 "../src/chess-window.vala"
	switch (property_id) {
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_LAYOUT_MODE_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_enum (value, chess_window_get_layout_mode (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_VIEW_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_view (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_SCENE_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_scene (self));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_GAME_PROPERTY:
#line 14 "../src/chess-window.vala"
		g_value_set_object (value, chess_window_get_game (self));
#line 14 "../src/chess-window.vala"
		break;
#line 2954 "chess-window.c"
		default:
#line 14 "../src/chess-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-window.vala"
		break;
#line 2960 "chess-window.c"
	}
}

static void
_vala_chess_window_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ChessWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_WINDOW, ChessWindow);
#line 14 "../src/chess-window.vala"
	switch (property_id) {
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_LAYOUT_MODE_PROPERTY:
#line 14 "../src/chess-window.vala"
		chess_window_set_layout_mode (self, g_value_get_enum (value));
#line 14 "../src/chess-window.vala"
		break;
#line 14 "../src/chess-window.vala"
		case CHESS_WINDOW_VIEW_PROPERTY:
#line 14 "../src/chess-window.vala"
		chess_window_set_view (self, g_value_get_object (value));
#line 14 "../src/chess-window.vala"
		break;
#line 2986 "chess-window.c"
		default:
#line 14 "../src/chess-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-window.vala"
		break;
#line 2992 "chess-window.c"
	}
}

